#include "stdafx.h"
#include "chronicle.h"
#include "chronicleDlg.h"
#include "datfile.h"

struct hotfix *ntsp3hotfix;
struct regcheck *ntsp3regcheck;
struct hotfix *ntsp4hotfix;
struct regcheck *ntsp4regcheck;

void init(void)
{
	ntsp3hotfix=NULL;
	ntsp3regcheck=NULL;
	ntsp4hotfix=NULL;
	ntsp4regcheck=NULL;
}

void addhotfix(struct hotfix **head, char *article, char *desc, 
			  char *url,int risk)
{
	struct hotfix *newguy,*walker;

	newguy=(struct hotfix *)malloc(sizeof(struct hotfix));
	newguy->next=NULL;
	newguy->article=strdup(article);
	newguy->desc=strdup(desc);
	newguy->url=strdup(url);
	newguy->risk=risk;

	if (!*head)
		*head=newguy;
	else
	{
		walker =*head;
		while (walker->next!=NULL)
			walker=walker->next;

		walker->next=newguy;
	}
}

void addregcheck(struct regcheck **head, char *location, char *desc)
{
	struct regcheck *newguy,*walker;

	newguy=(struct regcheck *)malloc(sizeof(struct regcheck));
	newguy->next=NULL;
	newguy->location=location;
	newguy->desc=desc;

	if (!*head)
		*head=newguy;
	else
	{
		walker =*head;
		while (walker->next!=NULL)
			walker=walker->next;

		walker->next=newguy;
	}
}

int parse(void)
{
	FILE *f;
	char line[1024],*temp;
	char article[1024],desc[1024],url[1024];
	int sp=0,risk=0;

	f=fopen("chronicle.dat","r");
	if (!f)
		return 0;

	while (fgets(line,sizeof(line),f))
	{
		/* comments */

		line[strlen(line)-1]=0;

		if (line[0]=='#') continue;
		if (!strncmp(line,"SP4",3))
		{
			sp=1;
			continue;
		}
		if (!strncmp(line,"REGCHECK",8))
		{
			// Not dead yet
		}
		else if (!strncmp(line,"HOTFIX",6))
		{
			temp=strrchr(line,':');
			if (!temp)
				continue;
			*temp++=0;
			strncpy(article,temp,(sizeof(article)-1));
			if (article[strlen(article)-2]=='!')
			{
				switch(article[strlen(article)-1])
				{
					case 'E':risk=0;break;
					case 'I':risk=1;break;
					case 'W':risk=2;break;
					case 'D':risk=3;break;
					case 'R':risk=4;break;
					case 'S':risk=5;break;
					case 'A':risk=6;break;
					case 'P':risk=7;break;
				}
				article[strlen(article)-2]=0;
			}
			if (fgets(line,sizeof(line),f)==NULL)
				return 0;
			line[strlen(line)-1]=0;
			strncpy(desc,line,(sizeof(line)-1));
			if (fgets(line,sizeof(line),f)==NULL)
				return 0;
			line[strlen(line)-1]=0;
			strncpy(url,line,(sizeof(line)-1));
			if (!sp)
				addhotfix(&ntsp3hotfix,article,desc,url,risk);
			else
				addhotfix(&ntsp4hotfix,article,desc,url,risk);
		}
		else
		{
			return 0;
		}
	}

	fclose(f);
	return 1;
}